<?php

$block_name = _("TitleSearch");

/**
 * This class extends Horde_Block:: to provide a search of Wiki page
 * titles.
 *
 * $Horde: wicked/lib/Block/TitleSearch.php,v 1.13 2007/01/02 12:49:24 jan Exp $
 *
 * Copyright 2004-2007 The Horde Project (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Chuck Hagenbuch <chuck@horde.org>
 * @package Horde_Block
 */
class Horde_Block_Wicked_TitleSearch extends Horde_Block {

    var $_app = 'wicked';

    function _title()
    {
        return _("TitleSearch");
    }

    function _content()
    {
        require_once dirname(__FILE__) . '/../base.php';

        $page = Page::getPage('TitleSearch');
        $results = $page->render(WICKED_MODE_CONTENT, Util::getFormData('params'));
        if (is_a($results, 'PEAR_Error')) {
            return $results;
        }

        require_once 'Horde/Template.php';
        $template = new Horde_Template();
        $pages = array();
        foreach ($results as $page) {
            if (!empty($page['page_history'])) {
                $page = new StdHistoryPage($page);
            } else {
                $page = new StandardPage($page);
            }

            $pages[] = array('author' => $page->author(),
                             'created' => $page->formatVersionCreated(),
                             'name' => $page->pageName(),
                             'context' => false,
                             'url' => $page->pageUrl(),
                             'version' => $page->version());
        }
        $template->set('pages', $pages, true);
        $template->set('hits', false, true);

        return '<form method="get">' .  Util::formInput()
            . '<input type="text" size="10" name="params" /><input type="submit" class="button" value="'
            . _("Search") . '" /></form><table width="100%">'
            . $template->fetch(WICKED_TEMPLATES . '/pagelist/pagelist.html') . '</table>';
    }

}
