<?php
/**
 * Wicked external API interface.
 *
 * $Horde: wicked/lib/api.php,v 1.17 2007/01/10 15:22:07 jan Exp $
 *
 * This file defines Wicked's external API interface. Other applications
 * can interact with Wicked through this API.
 *
 * @package Wicked
 */

$_services['perms'] = array(
    'args' => array(),
    'type' => 'array'
);


function _wicked_perms()
{
    static $perms = array();
    if (!empty($perms)) {
        return $perms;
    }

    require_once dirname(__FILE__) . '/base.php';
    global $wicked;

    $perms['tree']['wicked']['pages'] = array();
    $perms['title']['wicked:pages'] = _("Pages");

    $perms['tree']['wicked']['pages'] = array();
    $perms['title']['wicked:pages'] = _("Pages");

    $perms['tree']['wicked']['pages']['AllPages'] = false;
    $perms['title']['wicked:pages:AllPages'] = 'AllPages';

    $perms['tree']['wicked']['pages']['LeastPopular'] = false;
    $perms['title']['wicked:pages:LeastPopular'] = 'LeastPopular';

    $perms['tree']['wicked']['pages']['MostPopular'] = false;
    $perms['title']['wicked:pages:MostPopular'] = 'MostPopular';

    $perms['tree']['wicked']['pages']['PageSearch'] = false;
    $perms['title']['wicked:pages:PageSearch'] = 'PageSearch';

    $perms['tree']['wicked']['pages']['RecentChanges'] = false;
    $perms['title']['wicked:pages:RecentChanges'] = 'RecentChanges';

    $perms['tree']['wicked']['pages']['TitleSearch'] = false;
    $perms['title']['wicked:pages:TitleSearch'] = 'TitleSearch';

    foreach ($wicked->getPages() as $pageName) {
        $pageId = $wicked->getPageId($pageName);
        $perms['tree']['wicked']['pages'][$pageId] = false;
        $perms['title']['wicked:pages:' . $pageId] = $pageName;
    }

    ksort($perms['tree']['wicked']['pages']);
    return $perms;
}
