#!/usr/bin/php
<?php
/**
 * This script reads permissions stored by name and stores them by page ID.
 *
 * $Horde: wicked/scripts/upgrades/2005-06-10_permissions.php,v 1.4 2006/04/18 15:39:41 jan Exp $
 *
 * Copyright 2005-2006 Cronosys, LLC <http://www.cronosys.com/>
 *
 * See the enclosed file COPYING for license information (ASL).  If you
 * did not receive this file, see http://www.horde.org/licenses/asl.php.
 */

@define('AUTH_HANDLER', true);
@define('HORDE_BASE', dirname(__FILE__) . '/../../..');
@define('WICKED_BASE', dirname(__FILE__) . '/../..');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();

require_once WICKED_BASE . '/lib/base.php';

echo "Updating permissions... ";

$nodes = &$perms->getTree();
foreach ($nodes as $perm_id => $node) {
    if ($perm_id == DATATREE_ROOT) {
        continue;
    }
    if (preg_match('/^wicked:pages:(.*)$/', $node, $matches)) {
        $page_id = $wicked->getPageId($matches[1]);
        if ($page_id !== false &&
            (!is_numeric($page_id) || $page_id == $matches[1])) {
            continue;
        }
        if ($page_id !== false) {
            /* We have a page, so copy it. */
            $permOb = &$perms->getPermission($node);
            if (!is_a($permOb, 'PEAR_Error')) {
                $newPermOb = &$perms->newPermission('wicked:pages:' . $page_id);
                $newPermOb->data = $permOb->getData();
                $newPermOb->save();
            }
        }
        /* Remove the old permission. */
        $permOb->delete();
    }
}

echo "done.\n";
exit;
